/*
 * ProgressDialog.java
 *
 * Created on March 27, 2006, 12:59 PM
 *
 */

package pl.psnc.vlab.util.swing.thread;

/**
 * ProgressDialog interface defines the util methods to manage Progress Dialog.
 * @author @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 * @deprecated classes from pl.psnc.vlab.util.thread should be used
 */
public interface ProgressDialog {
    
    /**
     * Starts the Progress Indicator dialog.
     * <PRE>Please note that a dialog should be run as a separate thread.</PRE>
     */
    public void start();
    
    
    /**
     * Stops the Progress Indicator dialog thread.
     */
    public void stop();
    
    
    /**
     * Set the visibility of the Progress Indicator dialog.
     * @param visible <CODE>true</CODE> to make the component visible; <CODE>false</CODE> to make it invisible
     */
    public void setVisible(boolean visible);
    
}
