/**
 * Created on 13 Jan 2009
 */
package pl.psnc.expres.broker.experiment;

import pl.psnc.expres.model.experiment.VlbiExperiment;

/**
 * {@link CorrelationValue} class - correlation session object. Stores
 * information about current correlation process.
 * 
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 * 
 */
public class CorrelationValue {

	/** Stores instance of field: vlbiExperiment */
	private final VlbiExperiment vlbiExperiment;

	/**
	 * Creates new instance of {@link CorrelationValue}
	 * 
	 * @param vlbiExperiment instance of vlbi experiment
	 */
	public CorrelationValue(VlbiExperiment vlbiExperiment) {
		this.vlbiExperiment = vlbiExperiment;
	}

	// -----------------------------------------------------------------------------------
	// ---- Setters / Getters

	/**
	 * Get value of field: vlbiExperiment
	 * 
	 * @return the vlbiExperiment
	 */
	public VlbiExperiment getVlbiExperiment() {
		return vlbiExperiment;
	}

}
