/**
 * Created on 30 Jan 2009
 */
package pl.psnc.expres.broker.remote.correlation;

import static org.junit.Assert.*;

import java.rmi.RemoteException;

import org.junit.Before;
import org.junit.Test;

/**
 * {@link CorrelationJobStubTest} class
 * 
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 * 
 */
public class CorrelationJobStubTest {

	/** Stores instance of field: correlationJobStub */
	private CorrelationJobStub correlationJobStub;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		correlationJobStub = new CorrelationJobStub(
				"http://expres.reef.man.poznan.pl:8080/correlationNode/services/CorellationJob");

	}

	/**
	 * Test method for
	 * {@link pl.psnc.expres.broker.remote.correlation.CorrelationJobStub#newChunkSetIsReady(pl.psnc.expres.broker.remote.correlation.CorrelationJobStub.NewChunkSetIsReady)}.
	 */
	@Test
	public void testNewChunkSetIsReady() {

	}

	/**
	 * Test method for
	 * {@link pl.psnc.expres.broker.remote.correlation.CorrelationJobStub#newCorrelationJob(pl.psnc.expres.broker.remote.correlation.CorrelationJobStub.NewCorrelationJob)}.
	 */
	@Test
	public void testNewCorrelationJob() {
		try {
			CorrelationJobStub.NewCorrelationJob nCorrelJob = new CorrelationJobStub.NewCorrelationJob();
			nCorrelJob.setParam0(99);
			nCorrelJob.setParam1(null);
			nCorrelJob.setParam2(null);

			correlationJobStub.newCorrelationJob(nCorrelJob);
		} catch (RemoteException e) {
			fail(e.getMessage());
		}
	}

	/**
	 * Test method for
	 * {@link pl.psnc.expres.broker.remote.correlation.CorrelationJobStub#addObserver(pl.psnc.expres.broker.remote.correlation.CorrelationJobStub.NewCorrelationJob)}.
	 */
	@Test
	public void testAddObserver() {
		try {
			CorrelationJobStub.AddObserver observer = new CorrelationJobStub.AddObserver();
			observer.setParam0(11);
			observer.setParam1("testowa lokalizacja");

			correlationJobStub.addObserver(observer);
		} catch (RemoteException e) {
			fail(e.getMessage());
		}
	}

}
